/* Copyright (c) The Turing Institute 1989 */

#ifndef lint
static char sccsid[] = "@(#)last.c 3.1 3/19/90 Tim Niblett (Turing Institute)";
#endif lint

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "last.h"

LastList *thelastlist = (LastList *)0,
	 *thecurrentlast = (LastList *)0;

LastList *newlast(previous, section)
LastList *previous;
char *section;
{
	LastList *tmp;

	tmp = (LastList *)malloc((unsigned)sizeof(LastList));
	tmp -> prev = previous;
	if (previous)
		previous -> next = tmp;
	tmp -> next = (LastList *)0;
	tmp -> sec = section;
	return(tmp);
}

void deletelast(last)
LastList *last;
{
	if (last)
		free(last);
}

void addlast(string)
char *string;
{
	if (!strncmp("Figure",string, 6))
		return;
	if (!thelastlist) {
		thelastlist = newlast(thelastlist, string);
		thecurrentlast = thelastlist;
		return;
	}
	thecurrentlast = newlast(thecurrentlast, string);
}

char *removelast()
{
	LastList *tmp = thecurrentlast;

	if (thecurrentlast) {
		if (thecurrentlast -> prev) {
			tmp = thecurrentlast -> prev;
			deletelast(thecurrentlast);
			tmp -> next = (LastList *)0;
			thecurrentlast = tmp;
			return(tmp -> sec);
		}
		return(thecurrentlast -> sec);
	}
	return("main");
}
