
/* "@(#)screen.h 3.1 3/19/90 Arthur van Hoff (Turing Institute)"; */


/*
 *	Definition of the screen buffer
 *	Each line contains data (char *) and update information for
 *	buffering;
 */

#define	abs(x)		(((x) > 0) ? (x) : (-(x)))
#define	max(x,y)	(((x) > (y)) ? (x) : (y))
#define	min(x,y)	(((x) < (y)) ? (x) : (y))

#define	TABWIDTH	8
#define	LF		'\012';
#define	CR		'\015';
#define	BS		'\010';

typedef struct {
	char	*ln;
	unsigned short	from, to, len, old_len;
} screen_line;

extern	screen_line *screen;
extern	int 	rows, cols, row, col, old_row, old_col,
		scroll_from, scroll_to, scroll_len, cursor_vis;
extern	char	*lines;

