
/* @(#)qlalloc.h 3.2 4/10/90 Arthur van Hoff (Turing Institute) */

#ifndef _qlalloc_
#define _qlalloc_

#define	QLTYPE			long		/* either short, int or long */
#define QLALIGNTYPE		double		/* either short, long double */

#define	QLALIGN			sizeof(QLALIGNTYPE)
#define	QLLARGEST		((QLTYPE)(~((QLTYPE)1 << ((QLALIGN << 3) - 1))))

#define	qlsize(p)		(((union ql_header *)(p))[-1].bytes)
#define qlalloc(bytes)		_qlalloc((QLTYPE)(bytes))
#define qlsetsize(p,bytes)	_qlsetsize(p,(QLTYPE)(bytes))
#define qlzero(p)		ZEROMEM(p,qlsize(p))

#define QLNEW(type,count)	((type *)qlalloc((count) * sizeof(type)))
#define QLNEWSTR(ptr,str)	(ptr) = (char *)qlalloc(strlen(str) + 1); strcpy(ptr,str)

union ql_header {
	QLTYPE		bytes;
	QLALIGNTYPE	padding;
};

extern void *_qlalloc();
extern int  _qlsetsize();
extern void qlfree();
extern void *qlcopy();

#endif _qlalloc_
