
#ifndef lint
static char sccsid[] = "@(#)drawps.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint

#include <stdio.h>

extern double	atof(), extrascale;
extern int	pictalso, lwoutput, pureps, rgbout, errlib;

main(argc,argv)
char *argv[];
{
	FILE	*fp = stdin;
	char	*prog = argv[0];

	argv++;
	while (--argc) {
		if (!strcmp(*argv,"-err")) {
			errlib = 1;
			argv++;
		} else if (!strcmp(*argv,"-rgb")) {
			rgbout = 1;
			argv++;
		} else if (!strcmp(*argv,"-latex")) {
			pureps = 1;
			argv++;
		} else if (!strcmp(*argv,"-news")) {
			lwoutput = 0;
			argv++;
		} else if (!strcmp(*argv,"-pict")) {
			pictalso = 0;
			argv++;
		} else if (!strcmp(*argv,"-scale")) {
			argv++;
			argc--;
			extrascale = atof(*argv);
			argv++;
		} else if (**argv == '-') {
			fprintf(stderr,"%s: invalid flag: %s\n",prog,*argv);
			fprintf(stderr,
		"usage: %s [-latex] [-news] [-pict] [-scale f] [-rgb] [-err]\n",prog);
			exit(1);
		} else {
			if ((fp = fopen(*argv,"r")) == NULL) {
				fprintf(stderr,"cannot open:%s\n",*argv);
				exit(1);
			}
		}
	}
	init_all();
	exec_fp(fp,"%drawps");
	generate_ps(stdout);
}
