
#ifndef lint
static char sccsid[] = "@(#)newsfile.c 3.2 5/17/90 Arthur van Hoff (Turing Institute)";
#endif lint


#include <stdio.h>

expand_path_name(file,efile)
char *file, *efile;
{
	char	*str;

	if (*file == '/')
		strcpy(efile,file);
	else if (*file == '~') {
		str = (char *)getenv("HOME");
		strcpy(efile,str);
		strcat(efile,file+1);
	} else {
		str = (char *)getenv("PWD");
		strcpy(efile,str);
		strcat(efile,"/");
		strcat(efile,file);
	}
}

news_path_name(file,efile)
char *file, *efile;
{
	char *str;

	if (*file == '/')
		strcpy(efile,file);
	else if (*file == '~') {
		str = (char *)getenv("HOME");
		strcpy(efile,str);
		strcat(efile,file+1);
	} else {
		/* try HOME */
		str = (char *)getenv("HOME");
		strcpy(efile,str);
		strcat(efile,file);
		if (access(efile,4)) {
			/* try HNHOME */
			str = (char *)getenv("HNHOME");
			strcpy(efile,str);
			strcat(efile,"/");
			strcat(efile,file);
			if (access(efile,4)) {
				/* try OPENWINHOME */
				str = (char *)getenv("OPENWINHOME");
				strcpy(efile,str);
				strcat(efile,"/");
				strcat(efile,file);
				if (access(efile,4))
					strcpy(efile,file);
			}
		} 
	}
}
