
% "@(#)hnterm.cps 3.3 5/23/90 Arthur van Hoff (Turing Institute)"; 

cdef prepare_canvas()
	begin
		MyCanvas setcanvas
		MyCanvas CanvasInfo begin
		/OnRight null def
		/CanvasMenu [
			(Copy)		(C) MenuKey	{
				NIL /TermCopy OnMenu
			}
			(Paste)		(V) MenuKey	{
				NIL /TermPaste OnMenu
			}
			MenuLine
			(Screen)	MenuActive	{/Screen TermFont}
			(Courier)	MenuActive	{/Courier TermFont}
			MenuLine
			(8 point)	MenuActive	{8 TermFSize}
			(10 point)	MenuActive	{10 TermFSize}
			(12 point)	MenuActive	{12 TermFSize}
			(14 point)	MenuActive	{14 TermFSize}
			(24 point)	MenuActive	{24 TermFSize}
		] /new GNMenu send def
		end
		FontName findfont FontSize scalefont setfont
		currentdict Color 
	end
	SetColor
	/MC exch def
	% erase a bit
	/F {rectpath fill} def
	/C {rectpath Clip} def
	/R {gsave rectpath 0 setgray 5 setrasteropcode fill grestore} def
	% scroll a bit
	/S {rectpath 0 exch copyarea} def

cdef fontinfo()
	[currentfont fontheight currentfont fontascent (0) stringwidth pop]
	PrintClient

cdef drawstring(x,y,string s)
	x y moveto s show
cdef drawstr(x,y,cstring s)
	x y moveto s show

cdef begin()
	{ gsave
cdef end()
	grestore } exec

cdef background()
	MC /FillColor get SetColor

cdef clip(x,y,w,h)
	x y w h C
cdef fill(x,y,w,h)
	x y w h F
cdef reverse(x,y,w,h)
	x y w h R

cdef scroll(x,y,w,h,d)
	d x y w h S
