#include <stdio.h>
#include <hypernews.h>

hn_any *mystack,*mymenu,*myslider;

int myhandler(any,argc,argv)
hn_any	*any,*argv[];
int	argc;
{
	int	myint;
	hn_any	*mynum,*myargs;

	myint = argv[0]->u.number;
	mynum = hn_new_number((double) myint/2);
	myargs = hn_new_array(mynum,NULL);
	hn_send(myslider,"SetValue",myargs);
	hn_free(myargs);
	return 1;
}

void quit()
{
	hn_stop();
}

main(argc,argv)
int	argc;
char	*argv[];
{
	if (!hn_start(argv[0])) {
		fprintf(stderr,"client1: hn_start() failed.\n");
		exit(1);
	}
  
	/* Define the interface objects */
	mystack = hn_new_object((char *) NULL,hn_Stack,"Stack1");
	mymenu = hn_new_object("Stack1",hn_PullDown,"MyMenu");
	myslider = hn_new_object("Stack1",hn_Slider,"MySlider");

	/* Register the messages */
	hn_register(myhandler,
		hn_new_message(mymenu,"DoWhatsRight",hn_new_array_body(1)));
	hn_register(quit,hn_quit);

	/* Connect to the stack */
	if (!hn_connect(mystack)) {
		fprintf(stderr,"client1: hn_connect() failed.\n");
		exit(1);
	}

	/* Wait for messages */
	hn_listen(hn_forever);  

	exit(0);
}
